// common.js

var ajaxFailAlert = "Failure accessing server. Please check your network settings and try again."

//Display error popup when Ajax call fails
function onAjaxFails()
{
	alert(ajaxFailAlert);
}

//Extract the content between <IRC:DIV> and </IRC:DIV>
function extractHTMLContentByIRCDiv(htmlContent)
{
    var index = htmlContent.indexOf("<IRC:DIV");
    var tailStr = htmlContent.substring(index);
    var lastIndex = tailStr.indexOf("</IRC:DIV>");
    var str = tailStr.substring(0,lastIndex+10);
	//var regex= /<IRC\:DIV.*>(.|\n|\r)*<\/IRC\:DIV>/i;
	//var matches = regex.exec(str);
	//if(matches)
	//{
		//return matches[0];
	//}
	//else
	//{
		//return null;
	//}
	return str;
}



//Ths fixed name of error message panel in Ajax page and normal page
var ajaxMessagePanel = 'ajaxMessagePanel';
var messagepanel = 'messagePanel';

function displayErrorMessage()
{
	var oAjaxMsgPanel = $(ajaxMessagePanel);
	if(oAjaxMsgPanel)
	{
		var oMsgPanel = $(messagepanel);
		if(oMsgPanel)
		{
			oMsgPanel.innerHTML = oMsgPanel.innerHTML.concat(oAjaxMsgPanel.innerHTML);
		}
	}
}

//Use this as a replacement for getElementById
function $(id)
{
	if(arguments.length>1)
	{
		var aResult=[];
		for(var i=0;i<arguments.length;i++)
		{
			aResult.push($(arguments[i]));
		}
		return aResult;
	}
	else
	{
		if(document.getElementById)
		{
			return document.getElementById(id);
		}
		else if(document.all)
		{
			return document.all[id];
		}
		return null;
	}
}

//If you do not know which one of multiple executions can succeed, use tryThese to try out one of them
function tryThese()
{
	var ret;
	for (var i = 0, length = arguments.length; i < length; i++) 
	{
		var arg = arguments[i];
		try 
		{
			ret = arg();
			break;
		} 
		catch (e) {}
	}
	
	return ret;
}

//Use this to remove '&nbsp;' from string
String.prototype.removeHtmlSpace=function()
{
	return this.replace(/(&nbsp;)/gi,"");
}

//return the deepest non-text child of a node
function getDeepestChild(node)
{
	while(node.nodeType == 1)
	{
		node = node.lastChild;
	}
	return node.parentNode;
}


//show waiting cursor and set inputs disable
function showWaitCursor(thisObj, thisEvent) {
	document.body.style.cursor='wait';
	window.setTimeout(disableAllInputs,200);
    return true;
}

//disable all the page inputs
function disableAllInputs()
{
	var oInputs = getAllInputs();
	for(var i = 0; i < oInputs.length; i++)
	{
		tryThese(function(){
		oInputs[i].disabled = true;
		oInputs[i].style.cursor='wait';});
	}
	disableAnchors();
}

//disable all the anchors
function disableAnchors()
{
	var anchors = document.getElementsByTagName("a");
	for(var i = 0; i < anchors.length; i++)
	{
		var href = anchors[i].getAttribute("href");
		if(href && href != "")
		{
			anchors[i].removeAttribute("href");
		}
	}
}

//get all the page inputs by tagname
function getAllInputs()
{
	var oRet = new Array;
	var oTemp = new Array;
	var inputTagNames = ["Input","Select","Button"];
	for(var i = 0; i < inputTagNames.length; i++)
	{
		oTemp = document.getElementsByTagName(inputTagNames[i]);
		if(oTemp.length > 0)
		{
			for(var j = 0; j < oTemp.length; j++)
			{
				oRet.push(oTemp[j]);
			}
		}
	}
	return oRet;
}

//create xmlHttpRequest object
var xmlHttpRequest = new Object();
xmlHttpRequest.send = function(url, method, callback, args, data, urlencoded)
{
	var req;
	try{
		// Create XMLHttpRequest object in non-Microsoft browsers
		req = new XMLHttpRequest();
	}catch (trymicrosoft) {
		 // Create XMLHttpRequest via MS ActiveX
		try {
			// Try to create XMLHttpRequest in later versions
      		// of Internet Explorer
			req = new ActiveXObject("Msxml2.XMLHTTP");
		} catch(othermicrosoft){
			try{
				req = new ActiveXObjcet("Microsoft.XMLHTTP");
			}catch(failed) {
				// Failed to create required ActiveXObject
				// Unable to create an XMLHttpRequest with ActiveX
				alert("create XMLHttpRequest object error!");
			}
		}
	}
	req.onreadystatechange = function() {
		
		try{
			// If the request's status is "complete"
			if(req.readyState == 4)
			{
				// Check that a successful server response was received
				//200:avaliable
				//401:unauthentication
				//403:forbidden
				//404:not found
				if(req.status==200)
				{
					callback(req,args);	
					displayErrorMessage();		
				}
			}
		}catch(err){
			//handle exception here
		}
	
	}
	if(method=="POST")
	{
		req.open("POST",url, true);
		req.setRequestHeader("Content-Type","text/xml;charset=UTF-8");
		if(urlencoded) req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		req.send(data);
	} else {
		req.open("GET",url,true);
		req.setRequestHeader("Content-Type","text/xml;charset=UTF-8");
		req.send(null);
	}
	return req;
}

xmlHttpRequest.sendRawPOST = function(url,callback,args,data)
{
	xmlHttpRequest.send(url,"POST",callback,args,data,false);
}
xmlHttpRequest.sendPOST = function(url,callback,args,data)
{
 	xmlHttpRequest.send(url,"POST",callback,args,data,true);
}
xmlHttpRequest.sendGET = function(url,callback,args)
{
	url += (url.indexOf("?")==-1?"?":"&amp;") + "timestamp=" + new Date().getTime();  
	return xmlHttpRequest.send(url,"GET",callback,args);
}