// logical.js for VolumeView.jsp

//function executed when the whole page is loaded

function launchWeclomePortlet(objHiddenValue,btn){
     if (objHiddenValue != ""){
     	btn.click();
     }
}

function postPageLoad() {
	$(namespace_g + "myForm:view_properties_button").disabled = true;
	$(namespace_g + "myForm:delete_button").disabled = true;
	//updated by hemingg 
	//set the select_all checkbox unchecked
	var selectAllElement = $(namespace_g + "myForm:volumeDataTable:_selectAll");
	if(selectAllElement!=null)
		$(namespace_g + "myForm:volumeDataTable:_selectAll").checked=false;
	setTableEvent();
	setTableClass();
}

//helper function, returns true if the row contains a checked box
function hasCheckedBox(row)
{
	var ret = false
	var oInputs = row.getElementsByTagName("Input");
	for(var j = 0; j < oInputs.length; j++)
	{
		if(oInputs[j].type == "checkbox" && oInputs[j].checked)
		{
			ret = true;
			break;
		}
	}
	return ret;
}

//formate the nls message,
//replace symbol masses ({i}) by each value of args 
function NlsFormatMsg(msgTemplate,args)
{
	var symbol = "";
	if(args!=null&&msgTemplate!="")
	{
		var len = args.length;
		for(var i=0;i<len;i++)
		{
			symbol = "{"+i+"}";
			var begin = msgTemplate.lastIndexOf(symbol);
			msgTemplate = msgTemplate.substr(0,begin) + args[i] + msgTemplate.substr(begin+3);
		}
	}
	return msgTemplate;
}

//helper function that sets the class for table rows
function setTableClass()
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	if(oTable)
	{
		var oRows = oTable.rows;
		for(var i = 1; i < oRows.length - 1; i++)
		{
			if(hasCheckedBox(oRows[i]))
			{
				oRows[i].className = "dmc_dataGrid_wpsTableHighlightedRow";
			}
			else
			{
				oRows[i].className = "dmc_dataGrid_wpsTableRow";
			}
		}
	}
}

//set event handler for all the table rows
function setTableEvent()
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	if(oTable)
	{
		var oRows = oTable.rows;
		//ignore header and footer
		for(var i = 1; i < oRows.length - 1; i++)
		{
			oRows[i].onclick = highLightRow;
		}
	}		
}

//event handler for click on table row
function highLightRow()
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	var oRows = oTable.rows;
	//ignore header and footer
	setTableClass();
	if(oCheckboxRow != null)
	{
		if(hasCheckedBox(oCheckboxRow))
		{
			this.className = "dmc_dataGrid_wpsTableHighlightedRow";
		}
		else
		{
			this.className = "dmc_dataGrid_wpsTableRow";
		}
		oCheckboxRow = null;
	}
	else
	{
		this.className = "dmc_dataGrid_wpsTableHighlightedRow";
	}
}

//event handler for click on delete button
function onDeleteClick(thisObj, thisEvent)
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	var oRows = oTable.rows;
	var volumeIdentitier="";
	//ignore header and footer
	for(var i = 1; i < oRows.length - 1; i++)
	{
		//The current row has a checked check box
		//Find the nickname of the corresponding volume
		if(hasCheckedBox(oRows[i]))
		{
				//The cell that contains volume nickname
				oCell = oRows[i].cells[1];
				var nickName = getDeepestChild(oCell).innerHTML.removeHtmlSpace();
				if(volumeIdentitier.length == 0)
				{
					volumeIdentitier += nickName;
				}
				else
				{
					volumeIdentitier += "\r                                  " + nickName;
				}
		}
	}
	if(volumeIdentitier.length != 0)
	{
		var args = new Array();
		args[0] = volumeIdentitier;
		var msg = NlsFormatMsg($(namespace_g + "form2:hiddenDeleteConfirm").value, args);
		var suggestion = confirm(msg);
	    
	    if(!suggestion) {
	      return false;
	    }
	    return showWaitCursor(thisObj, thisEvent);
	}
	
}

var oCheckboxRow = null;

//event handler for click on check box
function onCheckboxClick(thisObj, thisEvent)
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	var oInputs = oTable.getElementsByTagName("Input");
	var oCheckboxes = new Array();
	for(var i = 0; i < oInputs.length; i++)
	{
		if(oInputs[i].type == "checkbox" && oInputs[i].checked && oInputs[i].id != namespace_g + "myForm:volumeDataTable:_selectAll")
		{
			oCheckboxes.push(oInputs[i]);
		}
	}
	
	if(oCheckboxes.length == 0)
	{
		$(namespace_g + "myForm:delete_button").disabled = true;
		$(namespace_g + "myForm:view_properties_button").disabled = true;
	}
	else
	{
		if(oCheckboxes.length == 1)
		{
			$(namespace_g + "myForm:view_properties_button").disabled = false;
		}
		else
		{
			$(namespace_g + "myForm:view_properties_button").disabled = true;
		}
		$(namespace_g + "myForm:delete_button").disabled = false;
	}
	
	oCheckboxRow = thisObj.parentNode.parentNode;
}

//event handler for click on view property button
function onViewPropertyClick(thisObj, thisEvent) {
	//use 'thisObj' to refer directly to this component instead of keyword 'this'
	//use 'thisEvent' to refer to the event generated instead of keyword 'event'
	return showWaitCursor(thisObj, thisEvent);
}

//event handler for selection on array list
function onSelectArray(thisObj, thisEvent) {
	$(namespace_g + 'myForm').submit();
	return showWaitCursor(thisObj, thisEvent);
}

//event handler for click on select all box
function onSelectAll(thisObj)
{
	var oTable = $(namespace_g + "myForm:volumeDataTable");
	var oInputs = oTable.getElementsByTagName("Input");
	var oCheckBoxes = new Array;
	for(var i = 0; i < oInputs.length; i++)
	{
		if(oInputs[i].type == "checkbox")
		{
			oInputs[i].checked = thisObj.checked;
			oCheckBoxes.push(oInputs[i]);
		}		
	}
	//one select-single and one select-all checkbox is checked
	if(oCheckBoxes.length == 2 && thisObj.checked)
	{
		$(namespace_g + "myForm:view_properties_button").disabled = false;
	}
	else
	{
		$(namespace_g + "myForm:view_properties_button").disabled = true;
	}
	$(namespace_g + "myForm:delete_button").disabled = !thisObj.checked;
	setTableClass();
}